Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree
Class NodeImpl

    java.lang.Object
      net.sf.saxon.tree.NodeImpl

All Implemented Interfaces:
  Source, SourceLocator, FingerprintedNode, Item, NodeInfo, ValueRepresentation

Direct Known Subclasses:
  DocumentImpl, ElementImpl

    public abstract class NodeImpl

extends Object
implements NodeInfo, FingerprintedNode, SourceLocator

A node in the XML parse tree representing an XML element, character content, or attribute.

This is the top-level class in the implementation class hierarchy; it essentially contains all those methods that can be defined using other primitive methods, without direct access to data.

Author:
  Michael H. Kay

Field Summary
`static char[]` | `NODE_LETTER` Chararacteristic letters to identify each type of node, indexed using the node type values.

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`NodeImpl()`

Method Summary
`Value` | `atomize()` Get the typed value.
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`boolean` | `equals(Object other)` The equals() method compares nodes for identity.
`void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node within this document (The calling code will prepend a document identifier)
`String` | `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`String` | `getBaseURI()` Get the base URI for the node.
`int` | `getColumnNumber()` Get the column number of the node.
`Configuration` | `getConfiguration()` Get the configuration
`int[]` | `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`String` | `getDisplayName()` Get the display name of this node.
`int` | `getDocumentNumber()` Get the document number of the document containing this node.
`DocumentInfo` | `getDocumentRoot()` Get the root (document) node
`int` | `getFingerprint()` Get the fingerprint of the node.
`NodeInfo` | `getFirstChild()` Get first child - default implementation used for leaf nodes
`NodeInfo` | `getLastChild()` Get last child - default implementation used for leaf nodes
`int` | `getLineNumber()` Get the line number of the node within its source document entity
`String` | `getLocalPart()` Get the local name of this node.
`int` | `getNameCode()` Get the nameCode of the node.
`NamePool` | `getNamePool()` Get the NamePool
`NodeImpl` | `getNextInDocument(NodeImpl anchor)` Get the next node in document order
`NodeInfo` | `getNextSibling()` Get next sibling node
`NodeInfo` | `getParent()` Find the parent node of this node.
`String` | `getPrefix()` Get the prefix part of the name of this node.
`NodeImpl` | `getPreviousInDocument()` Get the previous node in document order
`NodeInfo` | `getPreviousSibling()` Get the previous sibling of the node
`String` | `getPublicId()` Get the public identifier of the document entity containing this node.
`NodeInfo` | `getRoot()` Get the root node
`CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`String` | `getSystemId()` Get the system ID for the node.
`int` | `getTypeAnnotation()` Get the type annotation of this node, if any
`SequenceIterator` | `getTypedValue()` Get the typed value of this node.
`String` | `getURI()` Get the URI part of the name of this node.
`boolean` | `hasChildNodes()` Determine whether the node has any children.
`int` | `hashCode()` The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an enumeration over the nodes reached by the given axis from this node
`AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an enumeration over the nodes reached by the given axis from this node
`void` | `sendNamespaceDeclarations(Receiver out, boolean includeAncestors)` Output all namespace nodes associated with this element.
`void` | `setSystemId(String uri)` Set the system ID of this node.

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`copy, getNodeKind, getStringValue`

Field Detail

### NODE_LETTER

    public static final char[] NODE_LETTER

  Chararacteristic letters to identify each type of node, indexed using the node type values. These are used as the initial letter of the result of generate-id()

Constructor Detail

### NodeImpl

    public NodeImpl()

Method Detail

### getStringValueCS

    public CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    the type annotation of the node, under the mask NamePool.FP_MASK, and optionally the bit setting IS_DTD_TYPE in the case of a DTD-derived ID or IDREF/S type (which is treated as untypedAtomic for the purposes of obtaining the typed value).

    The result is undefined for nodes other than elements and attributes.

### getColumnNumber

    public int getColumnNumber()

  Get the column number of the node. The default implementation returns -1, meaning unknown

  Specified by:
    `getColumnNumber` in interface `SourceLocator`

### getPublicId

    public String getPublicId()

  Get the public identifier of the document entity containing this node. The default implementation returns null, meaning unknown

  Specified by:
    `getPublicId` in interface `SourceLocator`

### getDocumentNumber

    public int getDocumentNumber()

  Get the document number of the document containing this node. For a free-standing orphan node, just return the hashcode.

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`

### getTypedValue

    public SequenceIterator getTypedValue()
                                   throws XPathException

  Get the typed value of this node. If there is no type annotation, we return the string value, as an instance of xs:untypedAtomic

  Specified by:
    `getTypedValue` in interface `Item`
  Returns:
    an iterator over the items in the typed value of the node or atomic value. The items returned by this iterator will always be atomic values.
  Throws:
    `XPathException` - where no typed value is available, for example in the case of an element with complex content

### atomize

    public Value atomize()
                  throws XPathException

  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `NodeInfo`
  Returns:
    the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
  Throws:
    `XPathException`
  Since:
    8.5

### setSystemId

    public void setSystemId(String uri)

  Set the system ID of this node. This method is provided so that a NodeInfo implements the javax.xml.transform.Source interface, allowing a node to be used directly as the Source of a transformation

  Specified by:
    `setSystemId` in interface `Source`

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### equals

    public boolean equals(Object other)

  The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().

  Specified by:
    `equals` in interface `NodeInfo`
  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
  Since:
    8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

### hashCode

    public int hashCode()

  The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()

  Specified by:
    `hashCode` in interface `NodeInfo`
  Overrides:
    `hashCode` in class `Object`
  Since:
    8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

### getNameCode

    public int getNameCode()

  Get the nameCode of the node. This is used to locate the name in the NamePool

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
  See Also:
    `allocate`, `getFingerprint`

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the node. This is used to compare whether two nodes have equivalent names. Return -1 for a node with no name.

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

### generateId

    public void generateId(FastStringBuffer buffer)

  Get a character string that uniquely identifies this node within this document (The calling code will prepend a document identifier)

  Specified by:
    `generateId` in interface `NodeInfo`
  Parameters:
    `buffer` - a buffer which will be updated to hold a string that uniquely identifies this node, across all documents.

### getSystemId

    public String getSystemId()

  Get the system ID for the node. Default implementation for child nodes.

  Specified by:
    `getSystemId` in interface `Source`
  Specified by:
    `getSystemId` in interface `SourceLocator`
  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.

### getBaseURI

    public String getBaseURI()

  Get the base URI for the node. Default implementation for child nodes.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node. This may be null if the base URI is unknown.

### compareOrder

    public final int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Returns:
    the Configuration

### getNamePool

    public NamePool getNamePool()

  Get the NamePool

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the namepool

### getPrefix

    public String getPrefix()

  Get the prefix part of the name of this node. This is the name before the ":" if any.

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    the prefix part of the name. For an unnamed node, return an empty string.

### getURI

    public String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For the default namespace, return an empty string. For an unnamed node, return the empty string.

### getDisplayName

    public String getDisplayName()

  Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getLocalPart

    public String getLocalPart()

  Get the local name of this node.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    The local name of this node. For a node with no name, return "",.

### getLineNumber

    public int getLineNumber()

  Get the line number of the node within its source document entity

  Specified by:
    `getLineNumber` in interface `SourceLocator`
  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### getParent

    public final NodeInfo getParent()

  Find the parent node of this node.

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    The Node object describing the containing element or root node.

### getPreviousSibling

    public NodeInfo getPreviousSibling()

  Get the previous sibling of the node

  Returns:
    The previous sibling node. Returns null if the current node is the first child of its parent.

### getNextSibling

    public NodeInfo getNextSibling()

  Get next sibling node

  Returns:
    The next sibling node of the required type. Returns null if the current node is the last child of its parent.

### getFirstChild

    public NodeInfo getFirstChild()

  Get first child - default implementation used for leaf nodes

  Returns:
    null

### getLastChild

    public NodeInfo getLastChild()

  Get last child - default implementation used for leaf nodes

  Returns:
    null

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an enumeration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - The axis to be iterated over
  Returns:
    an AxisIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an enumeration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - The axis to be iterated over
    `nodeTest` - A pattern to be matched by the returned nodes
  Returns:
    an AxisIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### getAttributeValue

    public String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getRoot

    public NodeInfo getRoot()

  Get the root node

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the containing document

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root (document) node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document

### getNextInDocument

    public NodeImpl getNextInDocument(NodeImpl anchor)

  Get the next node in document order

  Parameters:
    `anchor` - the scan stops when it reaches a node that is not a descendant of the specified anchor node
  Returns:
    the next node in the document, or null if there is no such node

### getPreviousInDocument

    public NodeImpl getPreviousInDocument()

  Get the previous node in document order

  Returns:
    the previous node in the document, or null if there is no such node

### sendNamespaceDeclarations

    public void sendNamespaceDeclarations(Receiver out,
                                          boolean includeAncestors)
                                   throws XPathException

  Output all namespace nodes associated with this element. Does nothing if the node is not an element.

  Specified by:
    `sendNamespaceDeclarations` in interface `NodeInfo`
  Parameters:
    `out` - The relevant outputter
    `includeAncestors` - True if namespaces declared on ancestor elements must
  Throws:
    `XPathException`

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    `true` if the node has any children, `false` if the node has no children.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.